<template>
  <q-input
    :model-value="formattedValue"
    filled
    icon="las la-calendar"
    :label="_label"
    :hint="hint"
    :error="error"
    :error-message="errorMessage"
    :readonly="readonly"
  >
    <template #append>
      <q-icon name="las la-calendar" />
    </template>

    <template #default>
      <q-popup-proxy
        ref="popupProxy"
        @before-show="setProxyDate"
        transition-show="scale"
        transition-hide="scale"
      >
        <q-date
          v-model="proxyDate"
          default-view="Months"
          minimal
          emit-immediately
          @update:model-value="onUpdateProxyDate"
        />
      </q-popup-proxy>
    </template>
  </q-input>
</template>

<script>
import { date } from 'quasar'

import { DateMixin } from 'src/mixins/DateMixin'

export default {
  name: 'MonthSelectorInput',
  mixins: [DateMixin],
  props: {
    modelValue: {
      type: Object,
      default: null
    },
    label: {
      type: String,
      default: null
    },
    hint: {
      type: String,
      default: null
    },
    readonly: {
      type: Boolean,
      default: true
    },
    error: {
      type: Boolean,
      default: false
    },
    errorMessage: {
      type: String,
      default: null
    }
  },
  emits: ['update:model-value'],
  data () {
    return {
      proxyDate: null
    }
  },
  computed: {
    _label () {
      if (this.label !== null) {
        return this.label
      } else {
        return this.$gettext('Select a month')
      }
    },
    formattedValue () {
      return this.modelValue?.label
    }
  },
  methods: {
    setProxyDate () {
      if (this.modelValue) {
        const month = this.modelValue.month
        const monthInDate = month < 10 ? '0' + month : month
        this.proxyDate = `2100/${monthInDate}/01`
      }
    },
    onUpdateProxyDate (value, reason, details) {
      const month = details.month
      const dateAtMonth = new Date('2100', month - 1)
      const monthModel = {
        id: dateAtMonth.toLocaleString('en-GB', { month: 'long' }).toLowerCase(),
        month,
        label: date.formatDate(dateAtMonth, 'MMMM')
      }
      this.$emit('update:model-value', monthModel)
      this.$refs.popupProxy.hide()
    }
  }
}
</script>
